import fire
import os
import time
import torch
from torchvision import datasets, transforms
import glob
path = "./output/densenetcf10"


#CUDA_VISIBLE_DEVICES=0 python  demo.py --data ./tds --depth 100 --growth_rate 12 --seed 9999 --model_type maxout --Mense 4 --save ./testX --efficient True 

all_folder = glob.glob(path+"/*/")
epochs = 299
done_lst = []
notdone_lst =[] 
#save = save+"_"+str(growth_rate)+"_"+str(depth)+"_"+str(model_type)+"_"+str(seed)+"_"+str(Mense)+"_" 
def name_analyzer(title):
    ts = title.replace(path+"/","").split("_")
    if (len(ts)<=8):
        grate = ts[2]
        depth = ts[3]
        model_type= ts[4]
        version = ts[5]
        Mense = ts[6]
    else:
        grate = ts[3]
        depth = ts[4]
        model_type= ts[5]+"_"+ts[6]
        version = ts[7]
        Mense = ts[8]
    return grate,depth,model_type,version,Mense

filter_version= [0,1,2,3,4]
filter_model = ["iea","iea_nn","maxout","normal"]
filter_m = [2,4,8,16] 
filter_depth = [40,100]   
for f in all_folder:

    grate,depth,model_type,version,Mense = name_analyzer(f)
    if int(version) not in filter_version:
        continue
    if model_type not in filter_model:
        continue 
    if int(Mense) not in filter_m:
        continue
    if int(depth) not in filter_depth:
        continue
    print("Checking:", grate,depth,model_type,version,Mense,end="")

    with open(f+"epoch.txt","r") as h:
        epo = int(h.readline())
        
        if epo>= epochs:
            print("-----> Done")
            done_lst.append((f,(grate,depth,model_type,version,Mense)))
            os.system("CUDA_VISIBLE_DEVICES=0 python test.py --data ./tds --depth {0} --growth_rate 12 --seed {1} --model_type {2} --Mense {3} --save ./output/densenetcf10/save_{2} --efficient True >tmp.txt".format(depth,version,model_type,Mense))
            print (open('tmp.txt', 'r').read())
        else:
            notdone_lst.append((f,(grate,depth,model_type,version,Mense)))
            print("-----> Note Done")

 
print("*"*30)
print("Done List")
for f,d in done_lst: 
    print(f,": ", d)
 
print("*"*30)
print("NotDone List")
for f,d in notdone_lst: 
    print(f,": ", d)