import os 


versions = [0,1,2]


script_dict = {0:""" #!/bin/bash
VS={0}

for model in resnet20 resnet32 resnet44 resnet56 resnet110 
do
    echo "IEA Rest"
    CUDA_VISIBLE_DEVICES=0 python -u trainer.py --version=$VS   --arch=$model  --save-dir=./output/resnet_cifar_10/save_$model --model_type iea & 
done """,
1:"""#!/bin/bash
VS={0}
for model in resnet1202
do
    echo "IEA 1202"
    CUDA_VISIBLE_DEVICES=0 python -u trainer.py --version=$VS   --arch=$model  --save-dir=./output/resnet_cifar_10/save_$model --model_type iea & 
done """,
2:""" #!/bin/bash
VS={0}

for model in resnet20 resnet32 resnet44 resnet56 resnet110 
do
    echo "normal Rest"
    CUDA_VISIBLE_DEVICES=0 python -u trainer.py --version=$VS   --arch=$model  --save-dir=./output/resnet_cifar_10/save_$model --model_type normal & 
done """,
3:"""#!/bin/bash
VS={0}
for model in resnet1202
do
    echo "normal 1202"
    CUDA_VISIBLE_DEVICES=0 python -u trainer.py --version=$VS   --arch=$model  --save-dir=./output/resnet_cifar_10/save_$model --model_type normal & 
done """,
4:""" #!/bin/bash
VS={0}

for model in resnet20 resnet32 resnet44 resnet56 resnet110 
do
    echo "maxout Rest"
    CUDA_VISIBLE_DEVICES=0 python -u trainer.py --version=$VS   --arch=$model  --save-dir=./output/resnet_cifar_10/save_$model --model_type maxout & 
done """,
5:"""#!/bin/bash
VS={0}
for model in resnet1202
do
    echo "maxout 1202"
    CUDA_VISIBLE_DEVICES=0,1 python -u trainer.py --version=$VS   --arch=$model  --save-dir=./output/resnet_cifar_10/save_$model --model_type maxout & 
done """,}

for v in versions:
    for k in range(6):
        with open("run_{0}_{1}.sh".format(v,k), "w")  as f: 
            f.write(script_dict[k].format(v))
            f.close()
            
    
